class XDM_SCORM_WRAPPER {
  // load this in all html files of the provider (content provider)
  constructor(rpc) {
    this.rpc = rpc;

    this.dfid = "ba3e6da93139803d8105a5a7cebadfa2";
    this.tpid = "cbf9a6d9cfe332ce8d60c327192af9ce";
    this.api_endpoint = "/api/public/v1/stats/";

    // pool stats every 5s
    this.poolStatsSpeed = 5000;

    // SCORM 1.1 & 1.2
    this.scorm_getvalue_interval = undefined;
    this.pool_stats_12_interval = undefined;
    this.scorm_data = {
      'LMSInitialize': 'true',
      'LMSFinish': 'true',
      'LMSGetValue': {
        'cmi.core._children': undefined,
        'cmi.core.student_id': undefined,
        'cmi.core.student_name': undefined,
        'cmi.core.lesson_location': undefined,
        'cmi.core.credit': undefined,
        'cmi.core.lesson_status': 'incomplete',
        'cmi.core.entry': undefined,
        'cmi.core.score_children': undefined,
        'cmi.core.score.raw': undefined,
        'cmi.core.score.max': undefined,
        'cmi.core.score.min': undefined,
        'cmi.core.total_time': undefined,
        'cmi.core.lesson_mode': 'normal',
        'cmi.core.exit': undefined,
        'cmi.core.session_time': undefined,
        'cmi.suspend_data': undefined,
        'cmi.launch_data': undefined,
        'cmi.comments': undefined,
        'cmi.comments_from_lms': undefined,
        'cmi.objectives._children': undefined,
        'cmi.objectives._count': undefined,
        'cmi.objectives.n.id': undefined,
        'cmi.objectives.n.score._children': undefined,
        'cmi.objectives.n.score.raw': undefined,
        'cmi.objectives.n.score.max': undefined,
        'cmi.objectives.n.score.min': undefined,
        'cmi.objectives.n.status': undefined,
        'cmi.student_data._children': undefined,
        'cmi.student_data.mastery_score': undefined,
        'cmi.student_data.max_time_allowed': undefined,
        'cmi.student_data.time_limit_action': undefined,
        'cmi.student_preference._children': undefined,
        'cmi.student_preference.audio': undefined,
        'cmi.student_preference.language': undefined,
        'cmi.student_preference.speed': undefined,
        'cmi.student_preference.text': undefined,
        'cmi.interactions._children': undefined,
        'cmi.interactions._count': undefined,
        'cmi.interactions.n.id': undefined,
        'cmi.interactions.n.objectives._count': undefined,
        'cmi.interactions.n.objectives.n.id': undefined,
        'cmi.interactions.n.time': undefined,
        'cmi.interactions.n.type': undefined,
        'cmi.interactions.n.correct_responses._count': undefined,
        'cmi.interactions.n.correct_responses.n.pattern': undefined,
        'cmi.interactions.n.weighting': undefined,
        'cmi.interactions.n.student_response': undefined,
        'cmi.interactions.n.result': undefined,
        'cmi.interactions.n.latency': undefined,
      },
      'LMSSetValue': undefined,
      'LMSCommit': undefined,
      'LMSGetLastError': undefined,
      'LMSGetErrorString': undefined,
      'LMSGetDiagnostic': undefined,
    }

    // SCORM 2004
    this.scorm_2004_getvalue_interval = undefined;
    this.pool_stats_2004_interval = undefined;
    this.scorm_2004_data = {
      'Initialize': 'true',
      'Terminate': 'true',
      'GetValue': {
        'cmi._version': undefined,
        'cmi.comments_from_learner._children': undefined,
        'cmi.comments_from_learner.n.comment': undefined,
        'cmi.comments_from_learner.n.location': undefined,
        'cmi.comments_from_learner.n.timestamp': undefined,
        'cmi.comments_from_lms._children': undefined,
        'cmi.comments_from_lms._count': undefined,
        'cmi.comments_from_lms.n.comment': undefined,
        'cmi.comments_from_lms.n.location': undefined,
        'cmi.comments_from_lms.n.timestamp': undefined,
        'cmi.completion_status': undefined,
        'cmi.completion_threshold': undefined,
        'cmi.credit': undefined,
        'cmi.entry': undefined,
        'cmi.exit': undefined,
        'cmi.interactions._children': undefined,
        'cmi.interactions._count': undefined,
        'cmi.interactions.n.id': undefined,
        'cmi.interactions.n.type': undefined,
        'cmi.interactions.n.objectives._count': undefined,
        'cmi.interactions.n.objectives.n.id': undefined,
        'cmi.interactions.n.timestamp': undefined,
        'cmi.interactions.n.correct_responses._count': undefined,
        'cmi.interactions.n.correct_responses.n.pattern': undefined,
        'cmi.interactions.n.weighting': undefined,
        'cmi.interactions.n.learner_response': undefined,
        'cmi.interactions.n.result': undefined,
        'cmi.interactions.n.latency': undefined,
        'cmi.interactions.n.description': undefined,
        'cmi.launch_data': undefined,
        'cmi.learner_id': undefined,
        'cmi.learner_name': undefined,
        'cmi.learner_preference._children': undefined,
        'cmi.learner_preference.audio_level': undefined,
        'cmi.learner_preference.language': undefined,
        'cmi.learner_preference.delivery_speed': undefined,
        'cmi.learner_preference.audio_captioning': undefined,
        'cmi.location': undefined,
        'cmi.max_time_allowed': undefined,
        'cmi.mode': undefined,
        'cmi.objectives._children': undefined,
        'cmi.objectives._count': undefined,
        'cmi.objectives.n.id': undefined,
        'cmi.objectives.n.score._children': undefined,
        'cmi.objectives.n.score.scaled': undefined,
        'cmi.objectives.n.score.raw': undefined,
        'cmi.objectives.n.score.min': undefined,
        'cmi.objectives.n.score.max': undefined,
        'cmi.objectives.n.success_status': undefined,
        'cmi.objectives.n.completion_status': undefined,
        'cmi.objectives.n.progress_measure': undefined,
        'cmi.objectives.n.description': undefined,
        'cmi.progress_measure': undefined,
        'cmi.scaled_passing_score': undefined,
        'cmi.score._children': undefined,
        'cmi.score.scaled': undefined,
        'cmi.score.raw': undefined,
        'cmi.score.min': undefined,
        'cmi.score.max': undefined,
        'cmi.session_time': undefined,
        'cmi.success_status': undefined,
        'cmi.suspend_data': undefined,
        'cmi.time_limit_action': undefined,
        'cmi.total_time': undefined,
        'adl.nav.request': undefined,
        'adl.nav.request_valid.continue': undefined,
        'adl.nav.request_valid.previous': undefined
      },
      'SetValue': undefined,
      'Commit': undefined,
      'GetLastError': undefined,
      'GetErrorString': undefined,
      'GetDiagnostic': undefined,
    }
  }

  // SCORM 1.1 & 1.2

  poolLMSGetValue() {
    const _this = this;
    this.scorm_getvalue_interval = setInterval(() => {
      for (const [key, val] of Object.entries(_this.scorm_data.LMSGetValue)) {
        _this.LMSGetValue(key)
      }
    }, 1000)
  }

  stopPoolLMSGetValue() {
    clearInterval(this.scorm_getvalue_interval);
    this.scorm_getvalue_interval = undefined;
  }

  fetchStats12() {
    const cmi_elements = [
      'cmi.core.student_id',
      'cmi.core.student_name',
      'cmi.core.lesson_status',
      'cmi.core.score.raw',
      'cmi.core.total_time',
    ];

    this.LMSGetValues(cmi_elements).then((res) => {
      let data = {
        "tpid": this.tpid,
        "dfid": this.dfid,
        "cmi_stdid": res['cmi.core.student_id'],
        "cmi_stdn": res['cmi.core.student_name'],
        "cmi_ss": res['cmi.core.lesson_status'],
        "cmi_cs": null,
        "cmi_sr": res['cmi.core.score.raw'],
        "cmi_tt": res['cmi.core.total_time'],
      };

      fetch(this.api_endpoint, {
        method: 'POST',
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
      }).then((res) => {
        return res.json();
      }).then((data) => {
        // console.log(data);
      });
    });
  }

  poolStats12() {
    const _this = this;
    this.pool_stats_12_interval = setInterval(() => {
      _this.fetchStats12();
    }, _this.poolStatsSpeed)
  }

  stopPoolStats12() {
    clearInterval(this.pool_stats_12_interval);
    this.pool_stats_12_interval = undefined;
  }

  LMSInitialize(str) {
    console.log('calling LMSInitialize from provider');
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSInitialize(str, function (response) {
        _this.scorm_data.LMSInitialize = response;
        console.log('--------------------')
        console.log('response from LMSInitialize')
        console.log(response)
        console.log('--------------------')
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });

    this.poolLMSGetValue();
    this.fetchStats12();
    this.poolStats12();

    return this.scorm_data.LMSInitialize;
  }

  LMSFinish(str) {
    console.log('calling LMSFinish from provider');
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSFinish(str, function (response) {
        _this.scorm_data.LMSFinish = response;
        console.log('--------------------')
        console.log('response from LMSFinish')
        console.log(response)
        console.log('--------------------')
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      })
    });

    this.stopPoolLMSGetValue();
    this.fetchStats12()
    this.stopPoolStats12()

    return this.scorm_data.LMSFinish;
  }

  LMSGetValue(CMIElement) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSGetValue(CMIElement, function (response) {
        if(response && response !== "") {
          _this.scorm_data.LMSGetValue[CMIElement] = response;
        }
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });
    // console.log('-----------------------------');
    // console.log('LMSGetValue from provider : ' + CMIElement);
    // console.log(this.scorm_data.LMSGetValue);
    // console.log('-----------------------------');
    if(this.scorm_data.LMSGetValue[CMIElement] !== undefined) {
      return this.scorm_data.LMSGetValue[CMIElement];
    }
    return "";
  }

  LMSGetValues(CMIElements) {
    return new Promise((resolve, reject) => {
      this.rpc.LMSGetValues(CMIElements, function (response) {
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });
  }

  LMSSetValue(CMIElement, value) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSFinish(CMIElement, value, function (response) {
        _this.scorm_data.LMSSetValue = response;
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      })
    });
    if(this.scorm_data.LMSSetValue !== undefined) {
      return this.scorm_data.LMSSetValue;
    }
    return "true";
  }

  LMSCommit(str) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSCommit(str, function (response) {
        _this.scorm_data.LMSCommit = response;
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });
    if(this.scorm_data.LMSCommit !== undefined) {
      return this.scorm_data.LMSCommit;
    }
    return "true";
  }

  LMSGetLastError() {
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSGetLastError(function (response) {
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      })
    });
    return "0";
  }

  LMSGetErrorString(CMIErrorCode) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSGetErrorString(CMIErrorCode, function (response) {
        _this.scorm_data.LMSGetErrorString = response;
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });
    if(this.scorm_data.LMSGetErrorString !== undefined) {
      return this.scorm_data.LMSGetErrorString;
    }
    return "0";
  }

  LMSGetDiagnostic(CMIErrorCode) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.LMSGetDiagnostic(CMIErrorCode, function (response) {
        _this.scorm_data.LMSGetDiagnostic = response;
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj)
      });
    });
    if(this.scorm_data.LMSGetDiagnostic !== undefined) {
      return this.scorm_data.LMSGetDiagnostic;
    }
    return "";
  }

  // SCORM 2004

  poolGetValue() {
    const _this = this;
    this.scorm_2004_getvalue_interval = setInterval(() => {
      for (const [key, val] of Object.entries(_this.scorm_2004_data.GetValue)) {
        _this.GetValue(key)
      }
    }, 1000)
  }

  stopPoolGetValue() {
    clearInterval(this.scorm_2004_getvalue_interval);
    this.scorm_2004_getvalue_interval = undefined;
  }

  fetchStats2004() {
    const cmi_elements = [
        'cmi.learner_id',
        'cmi.learner_name',
        'cmi.success_status',
        'cmi.completion_status',
        'cmi.score.raw',
        'cmi.total_time',
    ];

    this.GetValues(cmi_elements).then((res) => {
      let data = {
        "tpid": this.tpid,
        "dfid": this.dfid,
        "cmi_stdid": res['cmi.learner_id'],
        "cmi_stdn": res['cmi.learner_name'],
        "cmi_ss": res['cmi.success_status'],
        "cmi_cs": res['cmi.completion_status'],
        "cmi_sr": res['cmi.score.raw'],
        "cmi_tt": res['cmi.total_time'],
      };

      fetch(this.api_endpoint, {
        method: 'POST',
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
      }).then((res) => {
        return res.json();
      }).then((data) => {
        // console.log(data);
      });
    });
  }

  poolStats2004() {
    const _this = this;
    this.pool_stats_2004_interval = setInterval(() => {
      _this.fetchStats2004();
    }, _this.poolStatsSpeed)
  }

  stopPoolStats2004() {
    clearInterval(this.pool_stats_2004_interval);
    this.pool_stats_2004_interval = undefined;
  }

  Initialize(str) {
    console.log('calling Initialize from provider');
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.Initialize(str, function (res) {
        _this.scorm_2004_data.Initialize = res;
        console.log('--------------------')
        console.log('response from Initialize')
        console.log(res)
        console.log('--------------------')
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });

    this.poolGetValue();
    this.fetchStats2004();
    this.poolStats2004();

    return this.scorm_2004_data.Initialize;
  }

  Terminate(str) {
    console.log('calling Terminate from provider');
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.Terminate(str, function (res) {
        _this.scorm_2004_data.Initialize = res;
        console.log('--------------------')
        console.log('response from Terminate')
        console.log(res)
        console.log('--------------------')
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });

    this.stopPoolGetValue();
    this.fetchStats2004();
    this.stopPoolStats2004();

    return this.scorm_2004_data.Terminate;
  }

  GetValues(CMIElements) {
    return new Promise((resolve, reject) => {
      this.rpc.GetValues(CMIElements, function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    })
  }

  GetValue(CMIElement) {
    const _this = this;
    const promise = new Promise((resolve, reject) => {
      this.rpc.GetValue(CMIElement, function (response) {
        if(response && response !== "") {
          _this.scorm_2004_data.GetValue[CMIElement] = response;
        }
        resolve(response);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    })
    // console.log('-----------------------------');
    // console.log('GetValue from provider : ' + CMIElement);
    // console.log(this.scorm_2004_data.GetValue);
    // console.log('-----------------------------');
    if(this.scorm_2004_data.GetValue[CMIElement] !== undefined) {
      return this.scorm_2004_data.GetValue[CMIElement];
    }
    return "";
  }

  SetValue(CMIElement, value) {
    const promise = new Promise((resolve, reject) => {
      this.rpc.SetValue(CMIElement, value, function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });
    return "true";
  }

  Commit(str) {
    const promise = new Promise((resolve, reject) => {
      this.rpc.Commit(str, function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });
    return "true";
  }

  GetLastError() {
    const promise = new Promise((resolve, reject) => {
      this.rpc.GetLastError(function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });
    return "0";
  }

  GetErrorString(CMIErrorCode) {
    const promise = new Promise((resolve, reject) => {
      this.rpc.GetErrorString(CMIErrorCode, function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });
    return "0";
  }

  GetDiagnostic(CMIErrorCode) {
    const promise = new Promise((resolve, reject) => {
      this.rpc.GetDiagnostic(CMIErrorCode, function (res) {
        resolve(res);
      }, function (errorObj) {
        console.error(errorObj)
        reject(errorObj);
      });
    });
    return "";
  }
}
